#!/bin/bash



. ./config

finish() {
#read -p "Press [Enter]"
eject $DRIVE 
}

dobeep() {
	let s=$1+1
    let s=s*100
        beep -f $s -l 200
        beep -f $2 -l 200     
}

DRIVE="$1"
num=${DRIVE//[\/dev\/sr]/}


AUDIOBOOK="$2"

if [ -z $DRIVE ]; then
 echo "No Drive Specified"
finish
fi

#mkdir /tmp/riptmp$num 2>&1 > /dev/null
#mount $DRIVE /tmp/riptmp$num 2>&1 > /dev/null
#umount $DRIVE /tmp/riptmp$num 2>&1 > /dev/null
#rmdir /tmp/riptmp$num 2>&1 > /dev/null


FIFO=/var/lock/ripwatch$num
if [ -e $FIFO ]; then
	rm -f $FIFO
fi
mkfifo $FIFO

echo "";
echo "Waiting for Disc Insertion"
cmd=`cat $FIFO`

/sbin/udevadm info -q env -n $DRIVE | grep ID_CDROM_MEDIA=1 > /dev/null
RESULT=$?
if [ $RESULT -ne 0 ]; then
 echo "NO MEDIA";
finish
fi

/sbin/udevadm info -q env -n $DRIVE | grep ID_CDROM_MEDIA_CD=1 > /dev/null
RESULT=$?

if [ $RESULT -eq 0 ]; then
 echo "CD"
 logfile=${DRIVE//[-._\/]/_}.log
 echo riplog$num

if [ -z "$2" ]; then
 #IS NOT AUDIO BOOK SO..
 #MP3

dobeep $num 1000
	   
 /usr/bin/ripit -d "$DRIVE" -o "$STORAGE_MP3" -b 256 -W  --comment cddbid -D '"$artist\_\_$album"'  --infolog "logs/autorip_"$logfile"" -Z 2 -O y --uppercasefirst --nointeraction
#chmod 777 "$STORAGE_MP3"  -R
 #FLAC

dobeep $num 1250
  /usr/bin/ripit -d "$DRIVE" -o "$STORAGE_CD" -c 2 -W  --comment cddbid -D '"$artist\_\_$album"' -e --infolog "logs/autorip_"$logfile"" -Z 2 -O y --uppercasefirst --nointeraction
#chmod 777 "$STORAGE_CD"  -R
else
 #IS AUDIO BOOK SO..
dobeep $num 1500
 mkdir -p "$STORAGE_AUDIOBOOK/BOOKRIP_DISK$2"
/usr/bin/ripit -d "$DRIVE" -o "$STORAGE_AUDIOBOOK/BOOKRIP_DISK$2" -c 3 -b 256 -W  --comment cddbid -D '"."' -T '"Chapter $tracknum - $trackname"' -e --infolog "logs/autorip_"$logfile"" -Z 2 -O y --uppercasefirst --nointeraction 
#chmod 777 "$STORAGE_CD_AUDIOBOOK"  -R
fi
fi

/sbin/udevadm info -q env -n $DRIVE | grep ID_CDROM_MEDIA_DVD=1 > /dev/null
RESULT=$?

if [ $RESULT -eq 0 ]; then
 echo "DVD";
 lsdvd "$DRIVE"
dobeep $num 1750

#DISKLABELG=`/sbin/udevadm info -q env -n $DRIVE | grep ID_FS_LABEL=`
DISKLABELG=`lsdvd "$DRIVE" | grep "Disc Title:" | sed 's/ //g'`
DISKLABEL=`cut -d ":" -f 2 <<< $DISKLABELG`  
ISOPATH="$STORAGE_DVD"/"$DISKLABEL"_$( date +%s ).iso

 echo Extracting ISO to $ISOPATH
ddrescue $DRIVE $ISOPATH
fi

/sbin/udevadm info -q env -n $DRIVE | grep ID_CDROM_MEDIA_BD=1 > /dev/null
RESULT=$?

if [ $RESULT -eq 0 ]; then
 echo "BD";
 dobeep $num 2000
 DISKLABELG=`/sbin/udevadm info -q env -n $DRIVE | grep ID_FS_LABEL=`
 DISKLABEL=`cut -d "=" -f 2 <<< $DISKLABELG`  
 BDPATH="$STORAGE_BD"/"$DISKLABEL"
 echo Outputdir is: $BDPATH
# The disc:x number is makemkvs method of enumerating drives. 
# Use makemkvcon -r --cache=1 info disc:9999 to get info
# Automatically trying to enumerate below
BLUERAYENUM=`makemkvcon -r --cache=1 info disc:9999 | grep $DRIVE | cut -c5`
echo makeMKV Blue-ray drive is number: $BLUERAYENUM
makemkvcon --debug --progress=-stdout --decrypt --cache=16 backup disc:"$BLUERAYENUM" "$BDPATH"
#chmod 777 "$BDPATH"  -R
fi




